

#define VERSION "2020_04_12"
// modif Ecriture dans HEF
// saisie de l'offset via COR=+xxx    en 1/100em de degre
// attention si RX UART reste connect
//MPLAB IPE message:
//We have detected some residual VDD voltage at the connector interface.
//Connection Failed.

//#define VERSION "2020_04_03"
// usage du dernier bloc HEF
// #define VERSION "2020_04_01"
// Test stockage Offset Tempertaure en Zone HEF
// sur 1er bloc en 1F80 ..OK
// #define VERSION "2020_03_22"
// suppresion affich BMP
//rajout mesure DS18B20
// suppression affichage taille 0 car utilise trop de ROM space
// Used RAM (bytes): 456 (45%)  Free RAM (bytes): 552 (55%)
// Used ROM (program words): 8108 (99%)  Free ROM (program words): 84 (1%)

#define Hardware_I2C
#define With_SQA         // avec IKALogic SQA50 Analyser


  //ac:shcem
  
   //ac:pinout

// cocher High voltage ICSP Options  MPLAB IPE et Pickit4
//
/*
// Hardware 16F1619  DIP20 :
PIN 1    VDD   +3.3  +5V
PIN 2    RA5
PIN 3    RA4  output --> Led Rouge ---2.2K--+5V
                    |---750--ICSP VPP  PIN 1 Pickit2
Pin 4     RA3/ MCLR |--- 6,8K --- +5V
Pin 5     RC5 ---> sortie SQA synchro ( ou Led Bleue )
pin 6     RC4
pin 7     RC3
pin 8     RC6
pin 9     RC7
pin 10    RB7  TX ----> UART ---> Ecran  fil Blanc Prolific USB
-----
Pin 20    VSS  --+5V
Pin 19    RA0  --- ICSP Data
Pin 18    RA1  --- ICSP Clock
Pin 17    RA2
Pin 16    RC0  --- <--- OWS sensor DS18B20
Pin 15    RC1  ---<-- input
pin 14    RC2
pin 13    RB4  <---> SDA I2C
pin 12    RB5  Rx  <--- UART <--- clavier fil vert  Prolific USB
pin 11    RB6  <--> SCL I2C
  */
  

#define DIRECTORY  "C:\\_MikroC\\_MesProjets_MikroC\\_Thermometre_Corporel_2020"
#define PROJECT "Thermometre_Corporel_16F1619_OLED_DS18B20_200412.mcppi"
#define SOURCE "Thermometre_Corporel_16F1619_UART1_RB7_TX_RB5_RX_I2C_RB6_SCL_RB4_SDA_DS18B20_RC2_2020_04_02.c"
#define Langage "MikroC 7.6.0"
#define PROCESSOR "PIC 16F1619 "
#define DEVICES  "OLED DISPLAY IIC I2C 0.91  128x32"
#define EEPROM  "No....ihex"
#define POWER_SUPPLY  " 3.3 to 5V"
#define FOSC "16.0 MHz"
#define BAUD "19200"
#define OTHERS "OLED_128x32_I2C1_remapp_16F1619_2020_04.h \r\n et *.c  OLED_128x32_Tables_2020_Ultra_Reduite.h"


#define OSCILLATEUR_INTERNE

/* config bits
CONFIG1 : $8007 : 0x38E4
CONFIG2 : $8008 : 0x1E83
CONFIG3 : $8009 : 0x3F1F
*/

#include "built_in.h"     // for  Hi  Lo ..etc

#define CLS 12
#define CR 13
#define LF 10
#define TAB 9
#define BACK 8
#define Beep 7
#define Separator 0x20   // space
#define Byte unsigned char
#define ON 0
#define OFF 1
//#define LCD_ADDR 0x4E  //
#define Word unsigned int


#define SSD1306_HARD_I2C1
#define  SSD1306_128_32
#define SSD1306_LCDWIDTH     128
#define  SSD1306_LCDHEIGHT    32

//#define OLED_ADDRESS   0x78    //@ I2C sur 8 bits

 // caraters speciaux
#define Point 0
#define Fleche_Bas 1
#define Fleche_Haut 2
#define Degre 3
#define HEF 0x1F80

#define OWS_Pin_Sensor_A  &PORTC,0     // sensor  A DS18B20 #1 OWS


const code char mesg0[]=" Mikroc 7.6.0 "PROCESSOR" \r\n";
const code char mesg1[]=" Directory : "DIRECTORY" \r\n";
const code char mesg2[]=" Projet : "PROJECT"\r\n";
const code char mesg3[]=" Source : "SOURCE" \r\n";
const code char mesg4[]=" DEVICE : "DEVICES" \r\n";
const code char mesg5[]=" Terminal pour dialogue et Visu  deroulement programme\r\n";
//const code char mesg6[]=" Alim ="POWER_SUPPLY"\r\n";
//const code char mesg7[]=" FOSC= "FOSC"\r\n";
//const code char mesg8[]=" Autres : "OTHERS"\r\n";
//const code char mesg9[]=" ";
const code char * Messages[]={mesg0,mesg1,mesg2,mesg3,mesg4,mesg5};
//const code char * Messages[]={mesg0,mesg1,mesg2,mesg3,mesg4,mesg5,mesg6,mesg7,mesg8,mesg9};


sbit Led_Rouge at LATA.B4;
sbit Led_Rouge_Dir at TRISA.B4;
//sbit SQA at LATC.B5;
//sbit SQA_Dir at TRISC.B5;
sbit Led_Bleue at LATC5_bit;
sbit Led_Bleue_Dir at TRISC.B5;
sbit Bavard at PORTC.B1;
sbit Bavard_Dir at TRISC.B1;

unsigned char OLED_ADRESS=0x78;

unsigned char RamBuffer[128];           // 32 klignes de 16 bytes
#define MAXLEN_BUFFER1 64
#define MAXLEN_TEXTE 64
Byte TEXTE[MAXLEN_TEXTE];
Byte * txt;
volatile unsigned char buffer1[MAXLEN_BUFFER1];
volatile unsigned int Flag_Buffer1;
volatile  unsigned char c1;
volatile unsigned int i1;
volatile unsigned int Index1;
volatile unsigned int CptErr;

Byte  CRam1[64];
char tmp[18];

int Etat;
unsigned char addr;
unsigned char Step;
unsigned char I2C_Retour[10];

int i,j,k,l,m,n;
float f1  ;
volatile int Flag_Timer1;
volatile unsigned int Cpt1;
volatile unsigned int Max_Timer1;


int FData[128];  // for write HEF
int RData[64];  // for write HEF
unsigned int Taille;
signed int Offset;
signed int New_Offset;
signed int kS;
char *p1;
int *p2;
char *p3;


//  Set TEMP_RESOLUTION to the corresponding resolution of used DS18x20 sensor:
//  (9 default setting; can be 9,10,11,or 12)
//  18B20: 12
const unsigned short TEMP_RESOLUTION = 12;
char Temp_DS18B20_A[9];

int temp_fraction;
char temp_whole,Signe;
unsigned  int tempLA=0;
unsigned   int tempA=0;
unsigned char IDA[9];
volatile char Temperat[30];
volatile unsigned char TP_Deg_A,TP_Deci_A;
volatile unsigned char Sign_A  ;
volatile unsigned int TAmb;
signed long DS18B20_Temp1=0;
signed long Ecart;

// ============ Functions  ======================

void Init_Hardware(void) ;
void strConstRamCpy(unsigned char *dest, const code char *source);
void Init_Hardware(void) ;
void CRLF1(void);
void UART1_Write_CText(const char *txt);
//char check_device(unsigned int dev_address);



#include "OLED_128x32_I2C1_remapp_16F1619_2020_04.h"



void Interrupts() iv 0004 ics ICS_AUTO
 {
 if ( (RCIE_bit==1) && ( RCIF_bit==1))
   {
   //TXREG1='$';
   // traitement separe des erreurs de COM
    // c1 = UART1_Read();
     c1=RCREG1;
      if (RCSTA1.OERR==1)    // voir parag 16.1.26 p273
      {
       RCSTA.CREN = 0 ;
       c1 = RCREG1;
       RCSTA.CREN = 1 ;
        CptErr++;

       }
      if(RCSTA.FERR==1 )
      {
      RCSTA.SPEN = 0 ;
      RCSTA.SPEN= 1 ;
      CptErr++;
       c1 = RCREG1;
      }
     if ((c1==CR) || (i1 > MAXLEN_BUFFER1-2))
      {
      Flag_Buffer1=1;
      if (i1 > MAXLEN_BUFFER1-2)  Flag_Buffer1=2;
      PIE1.RCIE=0 ; //interdit IT Reception UART
      buffer1[i1]=0;
      Index1=i1;
      i1=0;
      c1=0;
     }
     else
     {
        buffer1[i1]=c1;
        Index1=i1;
        i1++;
      }
   }
  /*
   // -----  timer 1  ----------------
   if  ( (TMR1IE_bit==1) && ( TMR1IF_bit==1))
   {  // Test "Peripheral Interrupt Request Register 1" for Timer1 Flag
     Cpt1--;

     if (Cpt1 <1)   // x100 ms  @16MHz
       {
        TMR1IE_bit=0; // stop comptage  timer1
        TMR1ON_bit=0;
        Flag_Timer1=1;
      }
     TMR1H         = 0x3C;
     TMR1L         = 0xB0;
     TMR1IF_bit=0;
   }
 */
  }

 void RAZ_Buffer1()
 {
    CptErr=0;
    c1 = RCREG1;
    c1=0;
     RCSTA.CREN = 1 ;
    Flag_Buffer1=0;
    PIE1.RCIE=1 ; //interdit IT Reception UART
     buffer1[i1]=0;
     Index1=i1;
     i1=0;
     c1=0;

  }
  

char  DS18B20_Build_value(unsigned int temp2write, char *Result)
 {
 int jj;
 const unsigned int RES_SHIFT = TEMP_RESOLUTION - 8;
  unsigned int temp_whole;
  char Sig=0;
  long temp_fraction;
  // Check if temperature is negative
    // Check if temperature is negative
  if (temp2write & 0x8000) {
     Sig=1  ;
      *(Result) = '-';
     temp2write = ~temp2write + 1;
     }
     else
     {
     Sig=0;
     *(Result) = ' ';
     }
  // Extract temp_whole
  temp_whole = temp2write >> RES_SHIFT ;
  // Convert temp_whole to characters
   *(Result+1) = (temp_whole/10)%10 + 48;             // Extract tens digit
  if   (*(Result+1)=='0')  *(Result+1)=' ';
   *(Result+2)=  temp_whole%10     + 48;             // Extract ones digit
  // Extract temp_fraction and convert it to unsigned int
  temp_fraction  = temp2write << (4-RES_SHIFT);
  temp_fraction &= 0x000F;
  *(Result+8)=0;
  //Ltrim( *(Result+1);
  temp_fraction= temp_fraction *  625;
     *(Result+3)='.';
  // Convert temp_fraction to characters
   *(Result+4) =  temp_fraction/1000    + 48;         // Extract thousands digit
   *(Result+5)= (temp_fraction/100)%10 + 48;         // Extract hundreds digit
   *(Result+6)= 0;         // Extract tens digit
   //*(Result+6)= (temp_fraction/10)%10  + 48;         // Extract tens digit
   *(Result+7)= 0; //temp_fraction%10      + 48;         // Extract ones digit
   *(Result+8)= 0;
  DS18B20_Temp1 = temp_whole * 100L + temp_fraction/10;
 if (Sig==1)   DS18B20_Temp1= -  DS18B20_Temp1;

 return Sig  ;
 }
  
// --- Copie le texte depuis FLASH ROM vers RAM
void strConstRamCpy(unsigned char *dest, const code char *source)
 {
  while (*source)*dest++ = *source++ ;
  *dest = 0 ;    // terminateur
}

#define Print UART1_Write_Text
#define CPrint UART1_Write_CText

void CRLF1()
{
 UART1_Remappable_Write(CR);
 UART1_Remappable_Write(LF);
}

void UART1_Write_CText(const char *txt)
 {
   while (*txt)
      UART1_Remappable_Write(*txt++);
      Delay_us(5);
}
/*
  void Init_Timer0()
  {
  //Prescaler 1:256; TMR0 Preload = 100; Actual Interrupt Time : 9.984 ms
  //  0 = Internal instruction cycle clock (FOSC/4)
  OPTION_REG.TMR0CS=0;
  //  Prescaler Rate Select bits  111 => 1/256
  OPTION_REG=OPTION_REG | 7 ; // PS2=1 PS1=1 PS0=1
  TMR0                 = 100;
  INTCON         = 00;
  TMR0IF_bit=0;
  PEIE_bit=0;
  TMR0IE_bit=0;
  GIE_bit=0;
}
*/

 void Init_Hardware()
{
  //REGISTER 6-1: BORCON: BROWN-OUT RESET CONTROL REGISTER
  BORCON.SBOREN=0;
  // no analog on PORT A,B,C
  ANSELA=0;
  TRISA=0xFF;
  Led_Rouge_Dir=0;  // RA4
  Led_Rouge=OFF;

  ANSELB=0;
  TRISB=0b11111111;
   // I2C pin must be set as input and Open drain
  WPUB=0 ;// Weak pull up on port B RB4-RB7 :  0=DISABLED
  //  1=open drain    0=push pull output
  ODCONB.B4 = 1;  // 1=open drain  output   SDA
  ODCONB.B6 = 1; // 1=open drain output   SCL
  ODCONB.B5 = 0;  // 0=push pull   input  RX
  ODCONB.B7 = 0;  // 0=push pull output   TX

  SLRCONB=0xF0; // 1 = Port pin slew rate is limited
  INLVLB=00; //1 = ST input used for PORT reads and interrupt-on-change
 
  ANSELC=0;
  TRISC=0b11011111;    // RC5 output SDA et Led Bleue
  WPUC=0b01100010 ;// Weak pull up on port C RC5 and RC1
  //HEF_Ecrit_Dir=1; //RC1;
  Bavard_Dir=1;
  Led_Bleue_Dir=0;
  ODCONC.B5 = 1; //
  //SQA_Dir=0;   //RC5        SQA  l
 // SQA=0;
  Led_Bleue_Dir=0;  // RC5 Led Bleue tire au +Vcc
  Led_Bleue=OFF;
  
  // page 230
  OPTION_REG.nWPUEN =0;  //  0= Weak pull-ups are enabled by individual WPUx latch values   1=disable WPUP
  /*
     RXPPS = 0D;   //RB5->EUSART:RX;
     RB7PPS = 0x12;   //RB7->EUSART:TX;
    RB6PPS = 0x10;   //RB6->MSSP:SCL;
    RB4PPS = 0x11;   //RB4->MSSP:SDA;
    SSPDATPPS = 0C;   //RB4->MSSP:SDA;
    SSPCLKPPS = 0E;   //RB6->MSSP:SCL;
    */
 }


 void Init_Fosc(void)
 {
  // internal FOSC
  OSCCON=0;
  // 16 MHZ
   OSCCON.IRCF3=1;
    OSCCON.IRCF2=1;
     OSCCON.IRCF1=1;
      OSCCON.IRCF0=1;
   // 1x = Internal oscillator block
   OSCCON.SCS1=1;
   OSCTUNE=0;
  }


void I2C1_TimeoutCallback(char errorCode) {

   if (errorCode == _I2C_TIMEOUT_RD) {
     // do something if timeout is caused during read
   }
   if (errorCode == _I2C_TIMEOUT_WR) {
     // do something if timeout is caused during write
   }
   if (errorCode == _I2C_TIMEOUT_START) {
     // do something if timeout is caused during start
   }
   if (errorCode == _I2C_TIMEOUT_REPEATED_START) {
     // do something if timeout is caused during repeated start
   }
}

 /*
unsigned char check_device(unsigned char dev_address)
{
char Etat;
Etat=0;
ACKSTAT_bit=0;
 SQA=1;
 I2C1_Remappable_Start();
SQA=0;
_asm nop;
SQA=1;
Etat= I2C1_Remappable_Wr(dev_address);
// while(I2C1_Remappable_Is_Idle()==0);
if(ACKSTAT_bit )
 {
  UART1_Remappable_Write('.'); //_CText(" is not found\r\n");
 }
 else
 {

 strConstRamCpy(txt,"\r\n Device at adresse : ");
 k=strlen(txt);
 ByteToStr(dev_address,CRam1);
  strcat(txt+k,CRam1);
  UART1_Remappable_Write_Text(txt);
  UART1_Write_CText(" found OK\r\n");
  Etat++;
  }
I2C1_Remappable_Stop();
SQA=0;
 return Etat;
}

    */
void Config_PPS(void)
{
  Unlock_IOLOCK();
    RC5PPS=0;
    RA4PPS=0;
 // USART1   RX, TX
   // ---------- Peripheral PIN and EUSART configuration ----------------------
   // PPS_Mapping(char rp_num, char input_output, char funct_name);
  //   PPS_Mapping(RB7, _OUTPUT, _TX_CK);
  //   PPS_Mapping(RB5, _INPUT, _RXPPS);
   // use  direct
    RB5PPS = 0x0D;      //  RX RB5
    RB7PPS= 0x12;       // TX RB7
   
   // --- I2C ----------------------
   // PPS_Mapping(RB4 , _OUTPUT, _SDA);
   // PPS_Mapping(RB6 , _OUTPUT, _SCK_SCL);   // Sets RB6 SCL I2C
  
  // TABLE 13-2: AVAILABLE PORTS FOR OUTPUT BY PERIPHERAL
  //   REGISTER 13-2: RxyPPS: PIN Rxy OUTPUT SOURCE SELECTION REGISTER
  //  bit 7-5=0   bit 4-0 RxyPPS<4:0>: Pin Rxy Output Source Selection bits
    RB6PPS = 0x10; // 0b00010000; // 16 RB6->MSSP:SCL
    RB4PPS = 0x11; //0b00010001; // 17  RB4->MSSP:SDA;
  // TABLE 13-1: PPS INPUT REGISTER RESET VALUES
  // SPI and I2C clock SSPCLKPPS RB6
   SSPCLKPPS = 0x0E;   //RB6->MSSP:SCL;
   // SPI and I2C data SSPDATPPS RB4
   SSPDATPPS = 0x0C;   //RB4->MSSP:SDA;
    RC5PPS=0;
    RA4PPS=0;
  Lock_IOLOCK();
}

/*
   void waitMSSP()
   {
  while(!PIR1.SSP1IF); // while SSPIF=0 stay here else exit the loop
  PIR1.SSP1IF = 0;
}
 */
 
 

void Wait_25mS(void)   { Delay_ms(25); }
void Wait_100mS(void)  { Delay_ms(100);}
void   Wait_250uS(void){ Delay_us(250);}
void Wait_500mS(void)  { Delay_ms(500);}

 
void Read_DS18B20()
{
      Ow_Reset(OWS_Pin_Sensor_A);         // Onewire reset signal
      Ow_Write(OWS_Pin_Sensor_A,0xCC);   // Issue command SKIP_ROM
      Ow_Write(OWS_Pin_Sensor_A,0x44);   // Issue command CONVERT_T
      Wait_100mS() ;
      Ow_Reset(OWS_Pin_Sensor_A);
      Ow_Write(OWS_Pin_Sensor_A,0xCC);   // Issue command SKIP_ROM
      Ow_Write(OWS_Pin_Sensor_A,0xBE);   // Issue command READ_SCRATCHPAD  for only one sensor
      Wait_100mS() ;
      tempLA = Ow_Read(OWS_Pin_Sensor_A);
      tempA = (Ow_Read(OWS_Pin_Sensor_A) << 8) + tempLA;


  }
    
void  Sauve_Offset_in_HEF(void)
{  int i,k;
     k=0;
     for (i=0;i<32;i++) FData[i]=0;
     IntToStr(Offset,CRam1);
     k=strlen(CRam1);
     for (i=0;i<k;i++ ) FData[i]=*(CRam1+i);

    // for debugging :
     Print(FData);CRLF1();
     UART1_Write_CText ("Erase #1 HEF\r\n");
      for (i=0; i<32;i++)
      {
        FLASH_Erase(0x1F80+i);
        Delay_ms(5);
      }
     UART1_Write_CText ("Write #1 HEF\r\n");
     FLASH_Write(0x1F80,&FData[0]);
     Wait_25mS();
 }

void Restitue_Offset_from_HEF(void)
{
int k,i;
     UART1_Write_CText (" 1rst value HEF= ");
     k=   FLASH_Read(0x1F80);
     WordToHex(k,CRam1);
     Print(CRam1); CRLF1();
    if (k<0x3FFF)
    {
     UART1_Write_CText ("Read Offset Temp.en HEF  ");
     j=0;
     p3=&RData[0];
     for (i=0;i<32;i++)
     {
      *(p3+i)= FLASH_Read(0x1F80+i);
     }
     RData[6]=0;
     Taille=strlen(RData);
      p3=&RData[0];
      if (    (*(p3)=='-')|| (*(p3)=='-') || (*(p3)==' '))
      {
           k=0;
           for (i=0;i<Taille;i++)
           {
           if (isdigit(*(p3+i)))  k++;
           }
           if (k=Taille)
           {
               Offset=atoi(p3);
               CPrint(" OK .. ");
               IntToStr(Offset,CRam1) ;
               Print(CRam1);
               CRLF1();
           }
           else
             CPrint("..BAD\r\n ");
        }
        else
       CPrint("Bad Lect. Offset\r\n");
    }
       else
    CPrint("HEF vierge\r\n");
}


void main()
 {
   Init_Fosc(); // internal FOSC  1111 =16 MHz HF
   // SCS FOSC; SPLLEN disabled; IRCF 16MHz_HF;
   // OSCCON = 0x78;
   // OSCTUNE = 00;
    Init_Hardware() ;
    Config_PPS();
   //6 x Clignotement Led Rouge (RA4)  et SQA (RC5)\r\n");
   // run once this , to check if MCU is running
    for (i=0;i<6;i++)
    {
      Led_Bleue=ON;
      Led_Rouge=ON;
     // SQA=1;
      Wait_100mS();
      Led_Bleue=OFF ;
      Led_Rouge=OFF;
    //  SQA=0;
      Wait_100mS();
    }

        // ******   INIT UART1 *****************
   txt=&TEXTE[0];
   UART1_Remappable_Init(19200);
   UART1_Write_CText(" Init UART1 RB7=TX RB5=RX \r\n");
   Wait_100mS();
   CRLF1()  ;

   UART1_Write_CText (" Presentation :\r\n");
   //for(i=0;i<9;i++)
   for(i=0;i<5;i++)
   {
    UART1_Write_CText(Messages[i]);
   }
//   Delay_ms(1000);
   Led_Bleue=OFF;
   CRLF1();
   GIE_bit=0;

  // SQA=0;   // synchro IKALOGIC SQA50 ANalyser
   for (i=0;i< MAXLEN_TEXTE-1;i++) TEXTE[i]=0;
   txt=&TEXTE[0];

   UART1_Write_CText(" I2C1 init RB4=SDA RB6=SCL\r\n" );
   I2C1_Remappable_Init(400000);
   I2C1_SetTimeoutCallback(10, I2C1_TimeoutCallback);
   I2C_Set_Active(&I2C1_Remappable_Start, &I2C1_Remappable_Repeated_Start, &I2C1_Remappable_Rd, &I2C1_Remappable_Wr, &I2C1_Remappable_Stop, &I2C1_Remappable_Is_Idle);

   OLED_ADRESS=0x78;
   addr=0x78;
  // UART1_Write_CText(" Init OLED I2C mode 2\r\n");
   OLED_Init();
    Wait_100mS();
   OLED_ON();
   Refresh_OLED() ;
   UART1_Write_CText(" OLED CLS \r\n");

   OLED_CLS();
   
  //   Pas assez de FLASH ROM pour autres Fontes de caracteres
  // UART1_Write_CText(" Test DS18B20 RC2 \r\n");
  // strConstRamCpy(txt," Temperature  ");
  // OLED_ShowStr(0,0,txt,2);
  // strConstRamCpy(txt," OWS DS18B20  ");
  // OLED_ShowStr(0,2,txt,2);
  // Delay_1sec();
  //
     Offset=0;
    Restitue_Offset_from_HEF();
    CRLF1();

     j=0;
     Ow_Reset(OWS_Pin_Sensor_A);    // Onewire reset signal
     Wait_250uS();
     Ow_Write(OWS_Pin_Sensor_A,0x33); // Read ROM (if only one device)
     Wait_250uS();
     c1=Ow_Read(OWS_Pin_Sensor_A);
     Wait_250uS();
     UART1_Write_CText(" Family Code: ");
    *(CRam1)=0;
     ByteToHex(c1,CRam1);
     UART1_Write_Text(CRam1);
     UART1_Write_CText(" ID1= ");
     for (i=0;i<6;i++)
     {
       c1=  Ow_Read(OWS_Pin_Sensor_A);
       Wait_25mS();
       IDA[i]=c1;
       *(CRam1)=0;
        ByteToHex(c1,CRam1);
       UART1_Write_Text(CRam1);
      }
      CRLF1();
      

     UART1_Write_CText("  CRC= ");
     c1=  Ow_Read(OWS_Pin_Sensor_A); // CRC
     *(CRam1)=0;
     ByteToHex(c1,CRam1);
     UART1_Write_Text(CRam1);
     CRLF1(); CRLF1();

     
     Read_DS18B20();
     DS18B20_Build_value(tempA,CRam1);
     UART1_Write_Text(CRam1);
     CRLF1();

     
     
     Led_Rouge=OFF;
     Led_Bleue=OFF;

     if(Bavard==0)
     {
       CPrint(" BAVARD ON ");   // Pin RC1=0
       }
     else
     {
      CPrint(" Mode Muet ");   // pin RC1=1
     }
     CRLF1();

     PEIE_bit=1;
     GIE_bit=1;
     RAZ_Buffer1();
  
    do
    {
      *(CRam1)=0;
      UART1_Write_CText("TB=");   // Temp. brute capteur
      Read_DS18B20() ;
      DS18B20_Build_value(tempA,CRam1);
      k=strlen(CRam1);
      strConstRamCpy(CRam1+k,"C;");
      UART1_Write_Text(CRam1);

       IntToStr(Offset,CRam1);
       UART1_Write_CText(" Ofs=");
       Print(CRam1);

      
       UART1_Write_CText("; ");
       UART1_Write_CText("TC="); // TP*1000 corrigee
       *(CRam1)=0;
        kS=  (tempA*100)>>4;  // * 0.0625
        kS=kS+Offset;
        IntToStr(kS,CRam1);
        Ltrim(CRam1);
          Print(CRam1);
         CPrint("C ;");


      OLED_CLS();
      if (kS>0)
      {
       *(CRam1+6)=0;
       *(CRam1+5)=*(CRam1+3);
       *(CRam1+4)=*(CRam1+2);
       *(CRam1+3)='.';
       *(CRam1+2)=*(CRam1+1);
       *(CRam1+1)=*(CRam1);
       *(CRam1)='+';
       }
       else
       {
        *(CRam1+6)=0;
       *(CRam1+5)=*(CRam1+4);
       *(CRam1+4)=*(CRam1+3);
       *(CRam1+3)='.';

        }
            Print(CRam1);
         CPrint("C");
        
      OLED_ShowStr(0,0,CRam1,3);
      
      

     
       UART1_Write_CText("; Ec=");
       Ecart=DS18B20_Temp1 +Offset - 3750;     // Ofsset en 100 em de degre
       LongToStr(Ecart,CRam1);
       Ltrim(CRam1);
       UART1_Write_Text(CRam1);
       CRLF1();

      RAZ_Buffer1();
       Delay_1sec();
       
      if ((Ecart>-400) && (Ecart< 400))
       {
          Led_Bleue=ON;
          Led_Rouge=ON;
          Wait_500mS();
          Led_Bleue=OFF;
          Led_Rouge=OFF;
       }
       else
       {
       if ((Ecart>250))
       {
        Led_Bleue=OFF;
        Led_Rouge=ON;
          Wait_500mS();
         Led_Rouge=OFF;
        }

       if (Ecart< -250)
       {
        Led_Rouge=OFF;
        Led_Bleue=ON;
         Wait_500mS();
         Led_Bleue=OFF;
        }
       }
       



       
    if( Flag_Buffer1==1)
    {
        // for debugging
        // CPrint("Reu :");
       p1=strstr(buffer1,"COR=");
       k=strlen(p1+4);
      Print(buffer1);CRLF1();
       if ((p1>0) && (k>3) && ( (*(p1+4)=='-') ||(*(p1+4)==' ') ||(*(p1+4)=='+')))
       {
          // for debugging
          //Print(p1);
          //CRLF1();
          l=0;
          for (i=0;i<3;i++) l=l+ isdigit(*(p1+5+i));
          if (l==3) // all are ndigits
          {
          CPrint("New Offset : ");

          New_Offset=atoi(p1+4);
          IntToStr(New_Offset,CRam1);
          Print(CRam1); CRLF1();
        //   if ((New_Offset > -301 ) && (New_Offset<301))     // +-3C
        // special pour test affichage Signe - sur oled
          if ((New_Offset > -30001 ) && (New_Offset<30001))     // +-3C
           {
            CPrint(" OK");
            Offset=New_Offset;
            Sauve_Offset_in_HEF();
           }
           else
           {
            CPrint("\r\n Offset out of range +-3C (*100) \r\n ");
           }
        //   CRLF1();
         }
       }
       else    CPrint("\r\n Erreur de saisie COR=+XXX \r\n");
       
       p1=0;
     }
   }
   while(1);

 }
 
 /*
 

 Presentation :
 Mikroc 7.6.0 PIC 16F1619
 Directory : C:\_MikroC\_MesProjets_MikroC\_Thermometre_Corporel_2020
 Projet : Thermometre_Corporel_16F1619_OLED_DS18B20_200403.mcppi
 Source : Thermometre_Corporel_16F1619_UART1_RB7_TX_RB5_RX_I2C_RB6_SCL_RB4_SDA_DS18B20_RC2_2020_04_02.c
 DEVICE : OLED DISPLAY IIC I2C 0.91  128x32

 I2C1 init RB4=SDA RB6=SCL
 OLED CLS
 1rst value HEF= 3FFF
HEF vierge

 Family Code: 28 ID1= AA6B96411401
  CRC= 17

 85.00
 Mode Muet
TB= 85.00C; Ofs=     0; TC=308C ;+30.8C; Ec=4750
TB= 22.68C; Ofs=     0; TC=2268C ;+22.68C; Ec=-863
TB= 22.68C; Ofs=     0; TC=2268C ;+22.68C; Ec=-863
TB= 22.75C; Ofs=     0; TC=2275C ;+22.75C; Ec=-800
TB=
COR=-010
 22.75C; Ofs=     0; TC=2275C ;+22.75C; Ec=-800
TB= 22.75C; Ofs=     0; TC=2275C ;+22.75C; Ec=-800
COR=-010
COR=-010
New Offset :    -10
 OK
Erase #1 HEF
Write #1 HEF
TB= 22.75C; Ofs=   -10; TC=2265C ;+22.65C; Ec=-810
TB= 22.81C; Ofs=   -10; TC=2271C ;+22.71C; Ec=-748
TB= 22.81C; Ofs=   -10; TC=2271C ;+22.71C; Ec=-748
 Init UART1 RB7=TX RB5=RX

 Presentation :
 Mikroc 7.6.0 PIC 16F1619
 Directory : C:\_MikroC\_MesProjets_MikroC\_Thermometre_Corporel_2020
 Projet : Thermometre_Corporel_16F1619_OLED_DS18B20_200403.mcppi
 Source : Thermometre_Corporel_16F1619_UART1_RB7_TX_RB5_RX_I2C_RB6_SCL_RB4_SDA_DS18B20_RC2_2020_04_02.c
 DEVICE : OLED DISPLAY IIC I2C 0.91  128x32

 I2C1 init RB4=SDA RB6=SCL
 OLED CLS
 1rst value HEF= 0020
Read Offset Temp.en HEF   OK ..    -10

 Family Code: 28 ID1= AA6B96411401
  CRC= 17

 22.81
 Mode Muet
TB= 22.81C; Ofs=   -10; TC=2271C ;+22.71C; Ec=-748
TB= 22.81C; Ofs=   -10; TC=2271C ;+22.71C; Ec=-748
TB= 22.81C; Ofs=   -10; TC=2271C ;+22.71C; Ec=-748
TB= 22.81C; Ofs=   -10; TC=2271C ;+22.71C; Ec=-748
TB= 22.81C; Ofs=   -10; TC=2271C ;+22.71C; Ec=-748



0 1 mikroCPIC1618.exe -MSF -DBG -pP16F1619 -RA -C -DL -O11111014 -fo16 -N"^C
C:\_MikroC\_MesProjets_MikroC\_Thermometre_Corporel_2020\Thermometre_Corporel_16F1619_OLED_DS18B20_200412.mcppi" -SP"^C
C:\_MikroC\mikroC PRO for PIC\Defs\" -SP"^C
C:\_MikroC\mikroC PRO for PIC\Uses\P16_Enh\" -SP"^C
C:\_MikroC\_MesProjets_MikroC\_Thermometre_Corporel_2020\" -SP"^C
C:\_MikroC\mikroC PRO for PIC\" -IP"^C
C:\_MikroC\mikroC PRO for PIC\Uses\P16_Enh\" "OLED_128x32_I2C1_remapp_16F1619_2020_04_02.c" "Thermometre_Corporel_16F1619_UART1_RB7_TX_RB5_RX_I2C_RB6_SCL_RB4_SDA_DS18B20_RC2_2020_04_12.c" "
_Lib_Math.mcl" "
_Lib_MathDouble.mcl" "
_Lib_System.mcl" "
_Lib_Delays.mcl" "
_Lib_CType.mcl" "
_Lib_CString.mcl" "
_Lib_CStdlib.mcl" "
_Lib_CMath.mcl" "
_Lib_Conversions.mcl" "
_Lib_OneWire.mcl" "
_Lib_FLASH_w32_e32.mcl" "
_Lib_PPS_1618_19.mcl" "
_Lib_UART_Remappable.mcl" "
_Lib_I2C_Remappable.mcl"
0 1139 Available RAM: 1008 [bytes], Available ROM: 8192 [bytes]
0 122 Compilation Started P16F1619.c
5814 123 Compiled Successfully P16F1619.c
0 122 Compilation Started
_Lib_Delays.c
123 123 Compiled Successfully
_Lib_Delays.c
12 1354  warning: "/*" within comment       0x40,0x40,0x80,0xF0,0x80,0x40,0x40,0x00,0x02,0x02,0x01,0x0F,0x01,0x02,0x02,0x00,//* 10      from C:/_MikroC/_MesProjets_MikroC/_Thermometre_Corporel_2020/OLED_128x32_I2C1_remapp_16F1619_2020_04_02.c: 10:    #include "OLED_128x32_Tables_2020_Ultra_Reduite.h" ^C
C:\_mikroc\_mesprojets_mikroc\_thermometre_corporel_2020\oled_128x32_tables_2020_ultra_reduite.h
0 122 Compilation Started oled_128x32_tables_2020_ultra_reduite.h
81 1163 Variable 'i' has been declared, but not used OLED_128x32_I2C1_remapp_16F1619_2020_04_02.c
211 1163 Variable 'i' has been declared, but not used OLED_128x32_I2C1_remapp_16F1619_2020_04_02.c
212 1163 Variable 'ca' has been declared, but not used OLED_128x32_I2C1_remapp_16F1619_2020_04_02.c
527 123 Compiled Successfully OLED_128x32_I2C1_remapp_16F1619_2020_04_02.c
296 1164 Variable 'j' has been eliminated by optimizer OLED_128x32_I2C1_remapp_16F1619_2020_04_02.c
297 1164 Variable 'xd' has been eliminated by optimizer OLED_128x32_I2C1_remapp_16F1619_2020_04_02.c
297 1164 Variable 'yd' has been eliminated by optimizer OLED_128x32_I2C1_remapp_16F1619_2020_04_02.c
513 1164 Variable 'k' has been eliminated by optimizer OLED_128x32_I2C1_remapp_16F1619_2020_04_02.c
0 122 Compilation Started Thermometre_Corporel_16F1619_UART1_RB7_TX_RB5_RX_I2C_RB6_SCL_RB4_SDA_DS18B20_RC2_2020_04_12.c
0 1004 interrupt handler (Interrupts at 0x0004) Thermometre_Corporel_16F1619_UART1_RB7_TX_RB5_RX_I2C_RB6_SCL_RB4_SDA_DS18B20_RC2_2020_04_12.c
288 1163 Variable 'jj' has been declared, but not used Thermometre_Corporel_16F1619_UART1_RB7_TX_RB5_RX_I2C_RB6_SCL_RB4_SDA_DS18B20_RC2_2020_04_12.c
557 1505 Suspicious pointer conversion Thermometre_Corporel_16F1619_UART1_RB7_TX_RB5_RX_I2C_RB6_SCL_RB4_SDA_DS18B20_RC2_2020_04_12.c
565 1505 Suspicious pointer conversion Thermometre_Corporel_16F1619_UART1_RB7_TX_RB5_RX_I2C_RB6_SCL_RB4_SDA_DS18B20_RC2_2020_04_12.c
580 1505 Suspicious pointer conversion Thermometre_Corporel_16F1619_UART1_RB7_TX_RB5_RX_I2C_RB6_SCL_RB4_SDA_DS18B20_RC2_2020_04_12.c
586 1505 Suspicious pointer conversion Thermometre_Corporel_16F1619_UART1_RB7_TX_RB5_RX_I2C_RB6_SCL_RB4_SDA_DS18B20_RC2_2020_04_12.c
587 1505 Suspicious pointer conversion Thermometre_Corporel_16F1619_UART1_RB7_TX_RB5_RX_I2C_RB6_SCL_RB4_SDA_DS18B20_RC2_2020_04_12.c
638 1509 Generated baud rate is 19231 bps (error = 0.16 percent) Thermometre_Corporel_16F1619_UART1_RB7_TX_RB5_RX_I2C_RB6_SCL_RB4_SDA_DS18B20_RC2_2020_04_12.c
879 123 Compiled Successfully Thermometre_Corporel_16F1619_UART1_RB7_TX_RB5_RX_I2C_RB6_SCL_RB4_SDA_DS18B20_RC2_2020_04_12.c
0 127 All files Compiled in 203 ms
0 1144 Used RAM (bytes): 932 (92%)  Free RAM (bytes): 76 (8%) Used RAM (bytes): 932 (92%)  Free RAM (bytes): 76 (8%)
0 1144 Used ROM (program words): 7972 (97%)  Free ROM (program words): 220 (3%) Used ROM (program words): 7972 (97%)  Free ROM (program words): 220 (3%)
0 125 Project Linked Successfully Thermometre_Corporel_16F1619_OLED_DS18B20_200412.mcppi
0 128 Linked in 110 ms
0 129 Project 'Thermometre_Corporel_16F1619_OLED_DS18B20_200412.mcppi' completed: 594 ms
0 103 Finished successfully: 12 avr. 2020, 19:25:13 Thermometre_Corporel_16F1619_OLED_DS18B20_200412.mcppi



*/